
//*****************************************************************************************//
//                                      Includes                                           //
//*****************************************************************************************//

#include "includes.all"

//*****************************************************************************************//
//                                       Object                                            //
//*****************************************************************************************//

void Object::tick () {
	//This could make an object rotate or change size or do nothing.
}

void Object::draw () {
	//Draw the faces in this object.
}

void Object::log () {
	//The type (it's implicit... it will be different for subclasses)...
	::log ("\nObject");

	//The faces...
	loopVector (faceIndex, faces)
		Face &face = *(faces [faceIndex]);
		::log ("\n\tFace %d:", faceIndex);
		Texture *texture = face.texture;
		::log ("\n\t\tTexture \"%s\":", texture == NULL ? "NULL" : texture->textureName);
		GamePointCollection &points = face.points;
		loopVector (pointIndex, points)
			GamePoint &point = *(points [pointIndex]);
//			::log ("\n\t\t%d: point [%3.2f,%3.2f,%3.2f] normal: [%3.2f,%3.2f,%3.2f] texture: [%3.2f,%3.2f].",
//				pointIndex, point.x, point.y, point.z, point.nx, point.ny, point.nz, point.tx, point.ty);
//			//Access point's x, y, z, nx, ny, nz, tx, ty
			::log ("\n\t\t%d: point [%3.2f,%3.2f,%3.2f] texture: [%3.2f,%3.2f].",
				pointIndex, point.x, point.y, point.z, point.tx, point.ty);
			//Access point's x, y, z, tx, ty
		endloop
	endloop
}
