/* $Header: /src2/opennurbs/opennurbs_dll.cpp 7     3/16/01 2:29p Dalelear $ */
/* $NoKeywords: $ */
/*
//
// Copyright (c) 1993-2001 Robert McNeel & Associates. All rights reserved.
// Rhinoceros is a registered trademark of Robert McNeel & Assoicates.
//
// THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
// ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF
// MERCHANTABILITY ARE HEREBY DISCLAIMED.
//				
// For complete openNURBS copyright information see <http://www.opennurbs.org>.
//
////////////////////////////////////////////////////////////////
*/

// opennurbs_dll.cpp : Defines the entry point for the Windows DLL application.
//
#include "opennurbs.h"

#if defined(ON_OS_WINDOWS) && defined(ON_DLL_EXPORTS)

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
  static BOOL bRunning = 0;
  if ( !bRunning ) {
    ON_OpenNURBS_Begin();
    bRunning = TRUE;
  }

  switch( ul_reason_for_call ) {

  case DLL_PROCESS_ATTACH:
    OutputDebugString("OpenNURBS DllMain() ul_reason_for_call = DLL_PROCESS_ATTACH\n");
    ON_ClassId::IncrementMark(); // make sure each DLL that each process that 
                                 // uses OpenNURBS has a unique mark.
    break;

  case DLL_THREAD_ATTACH:
    OutputDebugString("OpenNURBS DllMain() ul_reason_for_call = DLL_THREAD_ATTACH\n");
    break;

  case DLL_THREAD_DETACH:
    OutputDebugString("OpenNURBS DllMain() ul_reason_for_call = DLL_THREAD_DETACH\n");
    break;

  case DLL_PROCESS_DETACH:
    OutputDebugString("OpenNURBS DllMain() ul_reason_for_call = DLL_PROCESS_DETACH\n");
    break;

  default:
    OutputDebugString("OpenNURBS DllMain() ul_reason_for_call = ?\n");
    break;
  }

  return TRUE;
}

#endif
