/* $Header: /src2/opennurbs/opennurbs_exception.h 3     1/03/01 4:59p Dalelear $ */
/* $NoKeywords: $ */
/*
//
// Copyright (c) 1993-2001 Robert McNeel & Associates. All rights reserved.
// Rhinoceros is a registered trademark of Robert McNeel & Assoicates.
//
// THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
// ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF
// MERCHANTABILITY ARE HEREBY DISCLAIMED.
//				
// For complete openNURBS copyright information see <http://www.opennurbs.org>.
//
////////////////////////////////////////////////////////////////
*/

////////////////////////////////////////////////////////////////
//
//   Defines ON_Exception
//
////////////////////////////////////////////////////////////////

#if !defined(OPENNURBS_EXCEPTION_INC_)
#define OPENNURBS_EXCEPTION_INC_

///////////////////////////////////////////////////////////////////////////////
// Class CRhinoException
//   The functions in this toolkit throw exceptions when they encounter serious
//   errors.  These can be system errors (e.g. out_of_memory), file I/O
//   errors, or programmer error in calling the functions(e.g.illegal_input) A
//   programmer who wants to recover from any of these errors must enclose
//   the calling code in a try block and provide a catch block: 
//          catch (CRhinoException) { 
//				// handle exception here
//			} 
///////////////////////////////////////////////////////////////////////////////
class ON_CLASS ON_Exception
{
public:
	ON_Exception();
	ON_Exception( ON::exception_type );
	~ON_Exception();
  ON::exception_type m_type;
};

#endif
