/* $Header: /src2/opennurbs/opennurbs_line.h 7     1/03/01 4:59p Dalelear $ */
/* $NoKeywords: $ */
/*
//
// Copyright (c) 1993-2001 Robert McNeel & Associates. All rights reserved.
// Rhinoceros is a registered trademark of Robert McNeel & Assoicates.
//
// THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
// ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF
// MERCHANTABILITY ARE HEREBY DISCLAIMED.
//				
// For complete openNURBS copyright information see <http://www.opennurbs.org>.
//
////////////////////////////////////////////////////////////////
*/

#if !defined(ON_LINE_INC_)
#define ON_LINE_INC_

class ON_CLASS ON_Line
{
public:
  ON_Line();
  ON_Line( const ON_3dPoint&, const ON_3dPoint& );
  ~ON_Line();


  // line[0] = start point line[1] = end point
  ON_3dPoint& operator[](int);
  const ON_3dPoint& operator[](int) const;

  BOOL IsValid() const; // returns TRUE if from != to

  BOOL Create( const ON_3dPoint&, const ON_3dPoint& );

  double Length() const;
  ON_3dVector Direction() const;
  ON_3dVector Tangent() const;
  ON_3dPoint PointAt( double ) const;

  BOOL ClosestPointTo( const ON_3dPoint&, double* ) const;
  ON_3dPoint ClosestPointTo( const ON_3dPoint& ) const;

  // For intersections see ON_Intersect();

  BOOL Transform( const ON_Xform& );

  // rotate line about a point and axis
  BOOL Rotate(
        double,               // sin(angle)
        double,               // cos(angle)
        const ON_3dVector&, // axis of rotation
        const ON_3dPoint&   // center of rotation
        );
  BOOL Rotate(
        double,              // angle in radians
        const ON_3dVector&, // axis of rotation
        const ON_3dPoint&   // center of rotation
        );

  BOOL Translate(
        const ON_3dVector&
        );

public:
  ON_3dPoint from; // start point
  ON_3dPoint to;   // end point
};

#endif
