/* $Header: /src2/opennurbs/opennurbs_linestyle.h 3     1/03/01 4:59p Dalelear $ */
/* $NoKeywords: $ */
/*
//
// Copyright (c) 1993-2001 Robert McNeel & Associates. All rights reserved.
// Rhinoceros is a registered trademark of Robert McNeel & Assoicates.
//
// THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
// ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF
// MERCHANTABILITY ARE HEREBY DISCLAIMED.
//				
// For complete openNURBS copyright information see <http://www.opennurbs.org>.
//
////////////////////////////////////////////////////////////////
*/

////////////////////////////////////////////////////////////////
//
//   defines ON_LineStyle
//
////////////////////////////////////////////////////////////////

#if !defined(OPENNURBS_LINESTYLE_INC_)
#define OPENNURBS_LINESTYLE_INC_

///////////////////////////////////////////////////////////////////////////////
//
// Class ON_LineStyle
// 
class ON_CLASS ON_LineStyle
{
public:
	// Constructors & Conversions -     also default copy and assignment	
	ON_LineStyle(); // Default is solid line, default thickness, scale = 1
	~ON_LineStyle();
	ON_LineStyle(const ON_LineStyle&);
	ON_LineStyle( // built-in pattern
    ON::line_pattern,
    double,          // thickness in mm  0 to 
    double           // scale 1.0/16.0x to 16.0x
    );
  ON_LineStyle& operator=(const ON_LineStyle&);

  void Default();

  int Compare( const ON_LineStyle& ) const; // < 0 if this < arg, 0 ir this==arg, > 0 if this > arg

	ON::line_pattern Pattern() const;
	int PatternIndex() const;
  double Thickness() const; // in mm
  double Scale() const;     // 1/16X to 16X

  void SetPattern(ON::line_pattern); // use built-in patterh
  void SetPatternIndex( int );       // use custom line pattern from table
  void SetThickness(double); // in mm
  void SetScale(double);     // 1/16X to 16X

private:
	unsigned int m_ls;
};

#endif
