/* $Header: /src2/opennurbs/opennurbs_memory_new.cpp 6     5/10/01 10:56a Dalelear $ */
/* $NoKeywords: $ */
/*
//
// Copyright (c) 1993-2001 Robert McNeel & Associates. All rights reserved.
// Rhinoceros is a registered trademark of Robert McNeel & Assoicates.
//
// THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
// ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF
// MERCHANTABILITY ARE HEREBY DISCLAIMED.
//				
// For complete openNURBS copyright information see <http://www.opennurbs.org>.
//
////////////////////////////////////////////////////////////////
*/

#include "opennurbs_system.h"
#include "opennurbs_defines.h"
#include "opennurbs_memory.h"

/* SEE COMMENTS AT THE START OF opennurbs_memory.h */
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
//
// OPTIONAL replacements for operator new and operator delete that use 
// onmalloc()/onfree().  The openNURBS toolkit does NOT require you to
// override new and delete.  
//
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
#pragma message( " --- OpenNURBS overriding new and delete" )

void* operator new[]( size_t sz )
{
  return onmalloc(sz);
}

void operator delete[]( void* p )
{
  onfree(p);
}

void* operator new( size_t sz )
{
  return onmalloc(sz);
}

void operator delete( void* p )
{
  onfree(p);
}

