//***************************************************************************************
//
// File supervisor: Softimage 3D Games & 3D Bridge team
//
// (c) Copyright 2001-2002 Avid Technology, Inc. . All rights reserved.
//
//***************************************************************************************
/****************************************************************************************
THIS CODE IS PUBLISHED AS A SAMPLE ONLY AND IS PROVIDED "AS IS".
IN NO EVENT SHALL SOFTIMAGE, AVID TECHNOLOGY, INC. AND/OR THEIR RESPECTIVE 
SUPPLIERS BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
CONNECTION WITH THE USE OR PERFORMANCE OF THIS CODE . 
 
COPYRIGHT NOTICE. Copyright  1999-2002 Avid Technology Inc. . All rights reserved. 

SOFTIMAGE is a registered trademark of Avid Technology Inc. or its subsidiaries 
or divisions. Windows NT is a registered trademark of Microsoft Corp. All other
trademarks contained herein are the property of their respective owners. 
****************************************************************************************/
#if (_MSC_VER > 1000) || defined(SGI_COMPILER)
#pragma once
#endif

// FileHandler.h : Declaration of the CFileHandler

#ifndef __FILEHANDLER_H_
#define __FILEHANDLER_H_

#include "resource.h"       // main symbols
#include <XSIParser.h>


//class CXSIParser;

/////////////////////////////////////////////////////////////////////////////
// CFileHandler
class ATL_NO_VTABLE CFileHandler : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CFileHandler, &CLSID_FileHandler>,
	public ISupportErrorInfo,
	public IDispatchImpl<IFileHandler, &IID_IFileHandler, &LIBID_DOTXSIOBJLib>
{
public:
	CFileHandler()
	{
		// Create the XSIParser instance
	m_pXSIParser = new CXSIParser;
		//m_pdotXSIFileHandler = new CdotXSIFileHandler;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_FILEHANDLER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CFileHandler)
	COM_INTERFACE_ENTRY(IFileHandler)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IFileHandler
public:
	STDMETHOD(get_RootTemplates)(/*[out, retval]*/ IDispatch* *out_pTemplates);
	STDMETHOD(get_FileVersionMinor)(/*[out, retval]*/ long *out_plVersionMinor);
	STDMETHOD(get_FileVersionMajor)(/*[out, retval]*/ long *out_plVersionMajor);
	STDMETHOD(Read)();
	STDMETHOD(Write)();
	STDMETHOD(Create)(BSTR in_bstrFilename, BSTR in_bOpenMode);
	STDMETHOD(Close)();
	STDMETHOD(Open)(BSTR in_bstrFilename);
private:
	CXSIParser* m_pXSIParser;
protected:
	HRESULT CreateObject(BSTR pszProgID, IDispatch **ppdisp);
};

#endif //__FILEHANDLER_H_
