//***************************************************************************************
//
// File supervisor: Softimage 3D Games & 3D Bridge team
//
// (c) Copyright 2001-2002 Avid Technology, Inc. . All rights reserved.
//
//***************************************************************************************
/****************************************************************************************
THIS CODE IS PUBLISHED AS A SAMPLE ONLY AND IS PROVIDED "AS IS".
IN NO EVENT SHALL SOFTIMAGE, AVID TECHNOLOGY, INC. AND/OR THEIR RESPECTIVE 
SUPPLIERS BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
CONNECTION WITH THE USE OR PERFORMANCE OF THIS CODE . 
 
COPYRIGHT NOTICE. Copyright  1999-2002 Avid Technology Inc. . All rights reserved. 

SOFTIMAGE is a registered trademark of Avid Technology Inc. or its subsidiaries 
or divisions. Windows NT is a registered trademark of Microsoft Corp. All other
trademarks contained herein are the property of their respective owners. 
****************************************************************************************/
// Param.h : Declaration of the CParam

#ifndef __PARAM_H_
#define __PARAM_H_

#include "resource.h"       // main symbols
#include <XSIParser.h>

/////////////////////////////////////////////////////////////////////////////
// CParam
class ATL_NO_VTABLE CParam : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CParam, &CLSID_Param>,
	public ISupportErrorInfo,
	public IDispatchImpl<IParam, &IID_IParam, &LIBID_DOTXSIOBJLib>
{
public:
	CParam()
	{
		m_pParam = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_PARAM)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CParam)
	COM_INTERFACE_ENTRY(IParam)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IParam
public:
	STDMETHOD(get_Value)(/*[out, retval]*/ VARIANT *out_pvValue);
	STDMETHOD(put_Value)(/*[in]*/ VARIANT in_vValue);
	STDMETHOD(get_Name)(/*[out, retval]*/ BSTR *out_pbstrName);
	STDMETHOD(put_Name)(/*[in]*/ BSTR in_bstrName);
	STDMETHOD(FreeStringVariant)(VARIANT in_vValue);
	STDMETHOD(AllocateArray)(VARIANT* out_pvValue, long in_lSize);

	CdotXSIParam* GetParam() { return m_pParam; }
	void SetParam(CdotXSIParam* pParam) { m_pParam = pParam; }

private:

	CdotXSIParam*    m_pParam;
};

#endif //__PARAM_H_
