//***************************************************************************************
//
// File supervisor: Softimage 3D Games & 3D Bridge team
//
// (c) Copyright 2001-2002 Avid Technology, Inc. . All rights reserved.
//
//***************************************************************************************
/****************************************************************************************
THIS CODE IS PUBLISHED AS A SAMPLE ONLY AND IS PROVIDED "AS IS".
IN NO EVENT SHALL SOFTIMAGE, AVID TECHNOLOGY, INC. AND/OR THEIR RESPECTIVE 
SUPPLIERS BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
CONNECTION WITH THE USE OR PERFORMANCE OF THIS CODE . 
 
COPYRIGHT NOTICE. Copyright  1999-2002 Avid Technology Inc. . All rights reserved. 

SOFTIMAGE is a registered trademark of Avid Technology Inc. or its subsidiaries 
or divisions. Windows NT is a registered trademark of Microsoft Corp. All other
trademarks contained herein are the property of their respective owners. 
****************************************************************************************/
// Params.cpp : Implementation of CParams
#include "stdafx.h"
#include "DotXSIObj.h"
#include "Params.h"
#include "Param.h"

/////////////////////////////////////////////////////////////////////////////
// CParams

STDMETHODIMP CParams::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IParams
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}
//*********************************************************************************************
//
// Author:	Softimage 3D Games & 3D Bridge team
// Date  :	28/May/01
//
// @mfunc		Get the number of parameters in the collection
//
//********************************************************************
STDMETHODIMP CParams::get_GetCount(long *out_plCount)
{
	// Out param initialization
	*out_plCount = 0;

	// Check if the wrapper contains a dotXSIParams object
	if ( m_pParams == 0 ) return E_FAIL;

	*out_plCount = m_pParams->GetCount();

	return S_OK;
}
//*********************************************************************************************
//
// Author:	Softimage 3D Games & 3D Bridge team
// Date  :	28/May/01
//
// @mfunc		Add a paramter to the collection
//
//********************************************************************
STDMETHODIMP CParams::Add(IDispatch *in_pParam, long in_lPos)
{
	// Check if the wrapper contains a dotXSIParams object
	if ( m_pParams == 0 ) return E_FAIL;

	m_pParams->Add( ((CParam*) in_pParam)->GetParam(), in_lPos ); 
	return S_OK;
}
//*********************************************************************************************
//
// Author:	Softimage 3D Games & 3D Bridge team
// Date  :	28/May/01
//
// @mfunc		Create a new blank parameter
//
//********************************************************************
STDMETHODIMP CParams::get_CreateParam(IDispatch **out_ppParam)
{
	HRESULT l_hr;
	
	// Out parameter initialization
	*out_ppParam = 0;

	// Create the COM Wrapprer object
	CComObject<CParam>* l_pParamObj = NULL;
	
	if ( FAILED (l_hr = CComObject<CParam>::CreateInstance(&l_pParamObj) ) )
		return l_hr;


	// Create the new Param object and set it into the wrapper
	CdotXSIParam* l_pdotXSIParam = CreatedotXSIParam();

	if ( l_pdotXSIParam )
	{
		l_pParamObj->SetParam(l_pdotXSIParam);
	}
	else
	{
		return E_FAIL;
	}
	
	// Query the Param object for the good interface
	l_hr = l_pParamObj->QueryInterface(IID_IDispatch, (LPVOID*)out_ppParam);
	return l_hr;	
}
//*********************************************************************************************
//
// Author:	Softimage 3D Games & 3D Bridge team
// Date  :	28/May/01
//
// @mfunc		Remove a parameter from the collection
//
//********************************************************************
STDMETHODIMP CParams::Remove(long in_lIndex)
{
	// Check if the wrapper contains a dotXSIParams object
	if ( m_pParams == 0 ) return E_FAIL;

	m_pParams->Remove(in_lIndex);
	return S_OK;
}
//*********************************************************************************************
//
// Author:	Softimage 3D Games & 3D Bridge team
// Date  :	28/May/01
//
// @mfunc		Get a parameter from the collection
//
//********************************************************************
STDMETHODIMP CParams::get_Item(long in_lIndex, IDispatch **out_ppParam)
{
	HRESULT l_hr;

	// Out parameter initialization
	*out_ppParam = 0;

	// Check if the wrapper contains a dotXSIParams object
	if ( m_pParams == 0) return E_FAIL;

	// Create the COM Wrapprer object
	CComObject<CParam>* l_pParamObj = NULL;
	
	if ( FAILED (l_hr = CComObject<CParam>::CreateInstance(&l_pParamObj) ) )
		return l_hr;

	// Fetch the good Param and set it into the Param object
	CdotXSIParam* l_pdotXSIParam;
	m_pParams->Item( in_lIndex, &l_pdotXSIParam );
	l_pParamObj->SetParam( l_pdotXSIParam );

	// Query the Param object for the good interface
	l_hr = l_pParamObj->QueryInterface(IID_IParam, (LPVOID*)out_ppParam);

	return l_hr;
}
