//***************************************************************************************
//
// File supervisor: Softimage 3D Games & 3D Bridge team
//
// (c) Copyright 2001-2002 Avid Technology, Inc. . All rights reserved.
//
//***************************************************************************************
/****************************************************************************************
THIS CODE IS PUBLISHED AS A SAMPLE ONLY AND IS PROVIDED "AS IS".
IN NO EVENT SHALL SOFTIMAGE, AVID TECHNOLOGY, INC. AND/OR THEIR RESPECTIVE 
SUPPLIERS BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
CONNECTION WITH THE USE OR PERFORMANCE OF THIS CODE . 
 
COPYRIGHT NOTICE. Copyright  1999-2002 Avid Technology Inc. . All rights reserved. 

SOFTIMAGE is a registered trademark of Avid Technology Inc. or its subsidiaries 
or divisions. Windows NT is a registered trademark of Microsoft Corp. All other
trademarks contained herein are the property of their respective owners. 
****************************************************************************************/
// Template.h : Declaration of the CTemplate

#ifndef __TEMPLATE_H_
#define __TEMPLATE_H_

#include "resource.h"       // main symbols
#include <XSIParser.h>

/////////////////////////////////////////////////////////////////////////////
// CTemplate
class ATL_NO_VTABLE CTemplate : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CTemplate, &CLSID_Template>,
	public ISupportErrorInfo,
	public IDispatchImpl<ITemplate, &IID_ITemplate, &LIBID_DOTXSIOBJLib>
{
public:
	CTemplate()
	{
		m_pTemplate = NULL;
		m_pParser = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_TEMPLATE)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CTemplate)
	COM_INTERFACE_ENTRY(ITemplate)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// ITemplate
public:
	STDMETHOD(get_Params)(/*[out, retval]*/ IDispatch* *out_ppParams);
	STDMETHOD(get_UserFlags)(/*[out, retval]*/ long *out_pnUserFlags);
	STDMETHOD(put_UserFlags)(/*[in]*/ long in_nUserFlags);
	STDMETHOD(get_UserDataType)(/*[out, retval]*/ BSTR *out_pbstrDataType);
	STDMETHOD(put_UserDataType)(/*[in]*/ BSTR in_DataType);
	STDMETHOD(get_TemplateName)(/*[out, retval]*/ BSTR *out_pbstrTemplateName);
	STDMETHOD(put_TemplateName)(/*[in]*/ BSTR in_bstrTemplateName);
	STDMETHOD(get_SystemFlags)(/*[out, retval]*/ long *out_pnSysFlags);
	STDMETHOD(put_SystemFlags)(/*[in]*/ long in_nSysFlags);
	STDMETHOD(get_Parent)(/*[out, retval]*/ IDispatch* *out_ppParent);
	STDMETHOD(put_Parent)(/*[in]*/ IDispatch* in_pParent);
	STDMETHOD(get_CreateTemplates)(/*[out, retval]*/ IDispatch* *out_ppTemplates);
	STDMETHOD(get_Children)(/*[out, retval]*/ IDispatch* *out_ppTemplates);
	STDMETHOD(get_InstanceName)(/*[out, retval]*/ BSTR *out_pbstrName);
	STDMETHOD(put_InstanceName)(/*[in]*/ BSTR in_bstrName);
	void SetTemplate(CdotXSITemplate* in_pTemplate, CXSIParser* in_pParser);
	CdotXSITemplate* GetTemplate();
private:
	CdotXSITemplate*	m_pTemplate;
	CXSIParser*			m_pParser;
};

#endif //__TEMPLATE_H_
