//***************************************************************************************
//
// File supervisor: Softimage 3D Games & 3D Bridge team
//
// (c) Copyright 2001-2002 Avid Technology, Inc. . All rights reserved.
//
//***************************************************************************************
/****************************************************************************************
THIS CODE IS PUBLISHED AS A SAMPLE ONLY AND IS PROVIDED "AS IS".
IN NO EVENT SHALL SOFTIMAGE, AVID TECHNOLOGY, INC. AND/OR THEIR RESPECTIVE 
SUPPLIERS BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
CONNECTION WITH THE USE OR PERFORMANCE OF THIS CODE . 
 
COPYRIGHT NOTICE. Copyright  1999-2002 Avid Technology Inc. . All rights reserved. 

SOFTIMAGE is a registered trademark of Avid Technology Inc. or its subsidiaries 
or divisions. Windows NT is a registered trademark of Microsoft Corp. All other
trademarks contained herein are the property of their respective owners. 
****************************************************************************************/
// Templates.h : Declaration of the CTemplates

#ifndef __TEMPLATES_H_
#define __TEMPLATES_H_

#include "resource.h"       // main symbols
#include <XSIParser.h>

/////////////////////////////////////////////////////////////////////////////
// CTemplates
class ATL_NO_VTABLE CTemplates : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CTemplates, &CLSID_Templates>,
	public ISupportErrorInfo,
	public IDispatchImpl<ITemplates, &IID_ITemplates, &LIBID_DOTXSIOBJLib>
{
public:
	CTemplates()
	{
		m_pTemplates = NULL;
		m_pParser = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_TEMPLATES)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CTemplates)
	COM_INTERFACE_ENTRY(ITemplates)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// ITemplates
public:
	STDMETHOD(get_Item)(long in_lIndex, /*[out, retval]*/ IDispatch* *out_ppTemplate);
	STDMETHOD(get_CreateTemplate)(/*[out, retval]*/ IDispatch* *out_ppTemplate);
	STDMETHOD(Remove)(long in_lIndex);
	STDMETHOD(Add)(IDispatch *in_Template, long in_lPos);
	STDMETHOD(get_GetCount)(/*[out, retval]*/ long *out_plCount);
	STDMETHOD(SetXSIParser)(CXSIParser* in_pXSIParser);
	
	void SetTemplates(CdotXSITemplates* pTemplates,  CXSIParser* pParser) { m_pTemplates = pTemplates; m_pParser = pParser; }

private:
	CXSIParser* m_pParser;
	CdotXSITemplates* m_pTemplates;
};

#endif //__TEMPLATES_H_
