'
' Example of how to use the ActiveX FTK object.
'
'
' Mimic the XSIDump functionality in VBScript
'
' Robert Belanger (2002)
'
'
'
' Declare a function to dump one template
' This function will first dump all the parameters and then recursively calls
' itself for all its chldren.
'
Sub dumponetemplate( inputTemplate, indentation )
'
' Define the Variables
'
dim val, templateParam, paramIndex, ChildrenIndex, child
'
' Write out the name of the template name & instance name
' and open a brace.
'
' i.e. SI_Mesh cube {  
'
outputFile.WriteLine ( Space( indentation ) & inputTemplate.TemplateName & " " & inputTemplate.InstanceName & "{" )
'
' Now for each parameters that we have
'
for paramIndex = 0 to inputTemplate.Params.GetCount - 1
	set templateParam = inputTemplate.Params.Item( paramIndex )
	val = templateParam.value
	'
	' As dotXSI stores most of its values in float, then we just convert to single
	' to avoid the rouding errors
	'
	if typename ( val ) = "Double" then
		val = CSng( val )
	end if
	if typename ( val ) <> "Variant()" then
		outputFile.WriteLine( Space( indentation +2 ) &  templateParam.name & " = [" & val & "]" )
	else
		outputFile.WriteLine( Space( indentation +2 ) & "[[ParamIndex = " & paramIndex & "]] " & templateParam.name & " is an array of index [" & LBound( val ) & "," & UBound( val ) & "]" )
		for index = LBound( val ) to UBound( val ) 
			outputFile.WriteLine( Space( indentation + 6 ) & " [" & index & "] = " & val( index ) )
		next
	end if
next 
'
' Children
'
for ChildrenIndex = 0 to inputTemplate.Children.GetCount - 1
	call dumponetemplate( inputTemplate.Children.Item ( ChildrenIndex ) , indentation + 2 )
next
'
' Close the opening brace
'
outputFile.WriteLine( Space( indentation ) & "}" )
outputFile.WriteLine 
end Sub

'
'
' Create the Variables
'
dim outputFile, fso, dotXSIFile, dotXSIOutputFile

'
' Create two handlers (one to read and one to write the dotXSI file)
'
set dotXSIFile       = CreateObject("dotXSIObj.FileHandler")
set dotXSIOutputFile = CreateObject("dotXSIObj.FileHandler")
'
' Create the FileSystemObject so we can create file for output
'
Set fso = CreateObject("Scripting.FileSystemObject")
'
' Open and Read the dotXSI file
'
' You should fix the path to make sure it points to the provided file.
'
dotXSIFile.Open(".\\example.xsi")
dotXSIFile.Read

'
' Create the log file for the output
'
Set outputFile = fso.CreateTextFile("c:\log.bob", True)
'
' Output the Version of the file and the Count of top level templates
'
outputFile.WriteLine ( "FileVersion " &dotXSIFile.FileVersionMajor & " " & dotXSIFile.FileVersionMinor ) 
outputFile.WriteLine ( "Number of RootTemplates " & dotXSIFile.RootTemplates.GetCount )
outputFile.WriteLine

'
' Dump all the root templates recursively
'
for i = 0 to dotXSIFile.RootTemplates.GetCount - 1
	set child = dotXSIFile.RootTemplates.Item( i )
	call dumponetemplate( child, 0  )
next

'
' Exercise to copy one dotXSI file to another....
' The idea is simply to copy all the templates from one FileHandler to another and
' then write the dotXSIOutputFile
'
'
' Copy to Output
'
for i = 0 to dotXSIFile.RootTemplates.GetCount - 1
	dotXSIOutputFile.RootTemplates.Add dotXSIFile.RootTemplates.Item( i ), -1
next

'
' Create a new dotXSIFile in text mode
'
dotXSIOutputFile.Create "C:\output.xsi", "DOTXSI_FORMAT_TEXT" 
'
' Write it
'
dotXSIOutputFile.Write
'
'  Close all files
'
dotXSIOutputFile.Close
dotXSIFile.Close
outputFile.Close
'
' Tha Tha That's all folks!
'
logmessage "Done!"