//***************************************************************************************
//
// File supervisor: Softimage 3D Games & 3D Bridge team
//
// (c) Copyright 2001-2002 Avid Technology, Inc. . All rights reserved.
//
//***************************************************************************************
/****************************************************************************************
THIS CODE IS PUBLISHED AS A SAMPLE ONLY AND IS PROVIDED "AS IS".
IN NO EVENT SHALL SOFTIMAGE, AVID TECHNOLOGY, INC. AND/OR THEIR RESPECTIVE 
SUPPLIERS BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
CONNECTION WITH THE USE OR PERFORMANCE OF THIS CODE . 
 
COPYRIGHT NOTICE. Copyright  1999-2002 Avid Technology Inc. . All rights reserved. 

SOFTIMAGE is a registered trademark of Avid Technology Inc. or its subsidiaries 
or divisions. Windows NT is a registered trademark of Microsoft Corp. All other
trademarks contained herein are the property of their respective owners. 
****************************************************************************************/

//********************************************************************
// Includes
//********************************************************************
#include "stdafx.h"
#include "varconv.h"
#include "dotXSIParam.h"

HRESULT SI2COMStringArrayConv(SI_TinyVariant* in_SiVariant, VARIANT* out_pComVariant );
HRESULT COM2SIStringArrayConv(VARIANT* in_ComVariant, SI_TinyVariant* out_pSiVariant );

//********************************************************************
//	Global Declaration
//********************************************************************

//********************************************************************
// Author:	Softimage 3D Games & 3D Bridge team
// Date			:  02 August 2001
//
// @mfunc		Convert a SI_TinyVariant array into a COM standard variant array
//
//********************************************************************
HRESULT	ConvertToSiVariant( VARIANT *in_pVar, SI_TinyVariant * out_pTiny) 
{
	LPVARIANT	l_pVar;
	LPSAFEARRAY	l_psaValues = V_ARRAY( in_pVar );
	SafeArrayAccessData( l_psaValues, (void HUGEP **) &l_pVar);
	//
	// Get the type
	//
	DWORD l_dwType = V_VT( &l_pVar[0] );
	AllocateLocalXSIArray( out_pTiny, l_psaValues->rgsabound->cElements );
	//
	// Copy the value
	//
	SI_TinyVariant	l_pTV;

	for (ULONG i = 0; i < l_psaValues->rgsabound->cElements; i++ )
	{
		COM2SIVariant( &l_pVar[i], &l_pTV );
		switch (out_pTiny->variantType){
		case SI_VT_PFLOAT:
			switch (l_pTV.variantType) {
			case SI_VT_SHORT:
				out_pTiny->p_fVal[i] = (float) l_pTV.sVal;
				break;
			case SI_VT_INT:
				out_pTiny->p_fVal[i] = (float) l_pTV.nVal;
				break;
			case SI_VT_FLOAT:
				out_pTiny->p_fVal[i] = (float) l_pTV.fVal;
				break;
			case SI_VT_DOUBLE:
				out_pTiny->p_fVal[i] = (float) l_pTV.dVal;
				break;
			}
			break;
		case SI_VT_PINT:
			switch (l_pTV.variantType) {
			case SI_VT_SHORT:
				out_pTiny->p_nVal[i] = (long) l_pTV.sVal;
				break;
			case SI_VT_INT:
				out_pTiny->p_nVal[i] = (long) l_pTV.nVal;
				break;
			case SI_VT_FLOAT:
				out_pTiny->p_nVal[i] = (long) l_pTV.fVal;
				break;
			case SI_VT_DOUBLE:
				out_pTiny->p_nVal[i] = (long) l_pTV.dVal;
				break;
			case SI_VT_LONG:
				out_pTiny->p_nVal[i] = (long) l_pTV.lVal;
				break;
			}
		}
	}
	SafeArrayUnaccessData( l_psaValues );
	return S_OK;
}

HRESULT	SafeArrayFillFloatToDouble( DWORD in_dwSize, LPSAFEARRAY in_pSafeArray, float * in_pFloats )
{
	HRESULT	l_hr;

	LPVARIANT l_pdValues = NULL;

	l_hr = ::SafeArrayAccessData( in_pSafeArray, ( void HUGEP ** )&l_pdValues );
	if (FAILED( l_hr ) || (l_pdValues == NULL ))
	{
		return E_OUTOFMEMORY;
	}
	for( ULONG j = 0; j < in_dwSize; j++ )
	{
		V_R8( &l_pdValues[ j ] ) = (DOUBLE)in_pFloats[j];
		V_VT( &l_pdValues[ j ] ) = VT_R8;
	}

	l_hr = ::SafeArrayUnaccessData( in_pSafeArray );
	return l_hr;

}
HRESULT	SafeArrayFillDouble( DWORD in_dwSize, LPSAFEARRAY in_pSafeArray, double * in_pDoubles )
{
	HRESULT	l_hr;

	LPVARIANT l_pdValues = NULL;

	l_hr = ::SafeArrayAccessData( in_pSafeArray, ( void HUGEP ** )&l_pdValues );
	if (FAILED( l_hr ) || (l_pdValues == NULL ))
	{
		return E_OUTOFMEMORY;
	}
	for( ULONG j = 0; j < in_dwSize; j++ )
	{
		V_R8( &l_pdValues[ j ] ) = in_pDoubles[j];
		V_VT( &l_pdValues[ j ] ) = VT_R8;
	}

	l_hr = ::SafeArrayUnaccessData( in_pSafeArray );
	return l_hr;

}

HRESULT	SafeArrayFillInt( DWORD in_dwSize, LPSAFEARRAY in_pSafeArray, SI_Int * in_pInt )
{
	HRESULT	l_hr;

	LPVARIANT l_pdValues = NULL;

	l_hr = ::SafeArrayAccessData( in_pSafeArray, ( void HUGEP ** )&l_pdValues );
	if (FAILED( l_hr ) || (l_pdValues == NULL ))
	{
		return E_OUTOFMEMORY;
	}
	for( ULONG j = 0; j < in_dwSize; j++ )
	{
		V_I4( &l_pdValues[ j ] ) = in_pInt[j];
		V_VT( &l_pdValues[ j ] ) = VT_I4;
	}

	l_hr = ::SafeArrayUnaccessData( in_pSafeArray );
	return l_hr;

}

HRESULT SI2COMVariant(SI_TinyVariant* in_SiVariant, VARIANT* out_pComVariant )
{
	USES_CONVERSION;
	LPSAFEARRAY	l_psaValues = NULL;

	switch( in_SiVariant->variantType )
	{
	case SI_VT_BOOL:
		out_pComVariant->vt = VT_BOOL;
		// For the SI_TinyVariant of type SI_VT_BOOL, 1 is TRUE and 0 is FALSE
		// Since the VARIANT of type VT_BOOL wants -1 for TRUE and 0 for FALSE,
		// we need to multiply by -1
		out_pComVariant->boolVal = in_SiVariant->boolVal * (-1);
		break;
	case SI_VT_BYTE:
		out_pComVariant->vt = VT_I1;
		out_pComVariant->cVal = in_SiVariant->bVal;
		break;
	case SI_VT_UBYTE:
		out_pComVariant->vt = VT_UI1;
		out_pComVariant->bVal = in_SiVariant->ubVal;
		break;
	case SI_VT_SHORT:
		out_pComVariant->vt = VT_I2;
		out_pComVariant->iVal = in_SiVariant->sVal;
		break;
	case SI_VT_USHORT:
		out_pComVariant->vt = VT_UI2;
		out_pComVariant->uiVal = in_SiVariant->usVal;
		break;
	case SI_VT_INT:
		out_pComVariant->vt = VT_I4;
		out_pComVariant->lVal = in_SiVariant->nVal;
		break;
	case SI_VT_UINT:
		out_pComVariant->vt = VT_UINT;
		out_pComVariant->uintVal = in_SiVariant->unVal;
		break;
	case SI_VT_FLOAT:
		out_pComVariant->vt = VT_R8;
		out_pComVariant->dblVal = (double) in_SiVariant->fVal;
		break;
	case SI_VT_DOUBLE:
		out_pComVariant->vt = VT_R8;
		out_pComVariant->dblVal = in_SiVariant->dVal;
		break;
	case SI_VT_LONG:
		out_pComVariant->vt = VT_I4;
		out_pComVariant->lVal = in_SiVariant->lVal;
		break;
	case SI_VT_ULONG:
		out_pComVariant->vt = VT_UI4;
		out_pComVariant->ulVal = in_SiVariant->ulVal;
		break;
	case SI_VT_PBOOL:
		out_pComVariant->vt = VT_BYREF|VT_BOOL;
		out_pComVariant->pboolVal = (SHORT*)in_SiVariant->p_boolVal;
		break;
	case SI_VT_PBYTE:
		assert( FALSE );
		return E_FAIL; // Type not supported yet !!
		break;
	case SI_VT_PUBYTE:
		out_pComVariant->vt = VT_BYREF|VT_UI1;
		out_pComVariant->pbVal = in_SiVariant->p_ubVal;
		break;
	case SI_VT_PSHORT:
		out_pComVariant->vt = VT_BYREF|VT_I2;
		out_pComVariant->piVal = in_SiVariant->p_sVal;
		break;
	case SI_VT_PUSHORT:
		out_pComVariant->vt = VT_BYREF|VT_UI2;
		out_pComVariant->puiVal = in_SiVariant->p_usVal;
		break;
	case SI_VT_PINT:  
		l_psaValues = SafeArrayCreateVector( VT_VARIANT, 0, in_SiVariant->numElems );
		SafeArrayFillInt( in_SiVariant->numElems, l_psaValues, in_SiVariant->p_nVal );
		V_VT    ( out_pComVariant ) = VT_ARRAY | VT_VARIANT;
		V_ARRAY ( out_pComVariant ) = l_psaValues;
		break;
	case SI_VT_PUINT:
		out_pComVariant->vt = VT_BYREF|VT_UINT;
		out_pComVariant->puintVal = in_SiVariant->p_unVal;
		break;
	case SI_VT_PFLOAT:
		l_psaValues = SafeArrayCreateVector( VT_VARIANT, 0, in_SiVariant->numElems );
		SafeArrayFillFloatToDouble( in_SiVariant->numElems, l_psaValues, in_SiVariant->p_fVal );
		V_VT    ( out_pComVariant ) = VT_ARRAY | VT_VARIANT;
		V_ARRAY ( out_pComVariant ) = l_psaValues;
		break;
	case SI_VT_PDOUBLE:
		l_psaValues = SafeArrayCreateVector( VT_VARIANT, 0, in_SiVariant->numElems );
		SafeArrayFillDouble( in_SiVariant->numElems, l_psaValues, in_SiVariant->p_dVal );
		V_VT    ( out_pComVariant ) = VT_ARRAY | VT_VARIANT;
		V_ARRAY ( out_pComVariant ) = l_psaValues;
		break;
	case SI_VT_PLONG:
		out_pComVariant->vt = VT_BYREF|VT_I4;
		out_pComVariant->plVal = in_SiVariant->p_lVal;
		break;
	case SI_VT_PULONG:
		out_pComVariant->vt = VT_BYREF|VT_UI4;
		out_pComVariant->pulVal = in_SiVariant->p_ulVal;
		break;
	case SI_VT_PCHAR:
		out_pComVariant->vt = VT_BSTR;
		out_pComVariant->bstrVal = SysAllocString( A2W( in_SiVariant->p_cVal) );
		break;
	case SI_VT_PPCHAR: 
		////////////////////////////////////////////////////////////
		// IMPORTANT NOTE:
		// The Char* Array will be put into ONE BSTR.
		// EACH String in the BSTR is terminated by a '\0'
		// Another '\0' is appended after the LAST string.
		////////////////////////////////////////////////////////////
		// we allocate memory in this memory space. 
		// We should call FreeStringVariant() to free the memory when it's not needed anymore

		out_pComVariant->vt = VT_BSTR;
		return SI2COMStringArrayConv( in_SiVariant, out_pComVariant );
		break;
	case SI_VT_PVOID:
		out_pComVariant->vt = VT_BYREF;
		out_pComVariant->byref = in_SiVariant->p_voidVal;
		break;
	default: 
		return E_FAIL;
	}
	return S_OK;
}

//********************************************************************
// Author:	Softimage 3D Games & 3D Bridge team
// Date			:  06/12/2000
//
// @mfunc		Convert a COM standard variant into a SI_TinyVariant
//
//********************************************************************
HRESULT COM2SIVariant(VARIANT* in_ComVariant, SI_TinyVariant* out_pSiVariant )
{
	switch( in_ComVariant->vt)
	{
	case VT_BOOL:
		out_pSiVariant->variantType = SI_VT_BOOL;
		// For the VARIANT of type VT_BOOL, TRUE is -1 and FALSE is 0. 
		// Since the SI_TinyVariant wants 1 for TRUE and 0 for FALSE, we need
		// to multiply by -1
		out_pSiVariant->boolVal = in_ComVariant->boolVal  * (-1);
		break;
	case VT_I1:
		out_pSiVariant->variantType = SI_VT_BYTE;
		out_pSiVariant->bVal = in_ComVariant->cVal;
		break;
	case VT_UI1:
		out_pSiVariant->variantType =SI_VT_UBYTE ;
		out_pSiVariant->ubVal = in_ComVariant->bVal;
		break;
	case VT_I2:
		out_pSiVariant->variantType =SI_VT_SHORT ;
		out_pSiVariant->sVal = in_ComVariant->iVal;
		break;
	case VT_UI2:
		out_pSiVariant->variantType = SI_VT_USHORT;
		out_pSiVariant->usVal = in_ComVariant->uiVal;
		break;
	case VT_INT:
		out_pSiVariant->variantType = SI_VT_INT;
		out_pSiVariant->nVal = in_ComVariant->intVal;
		break;
	case VT_UINT:
		out_pSiVariant->variantType = SI_VT_UINT;
		out_pSiVariant->unVal = in_ComVariant->uintVal;
		break;
	case VT_R4:
		out_pSiVariant->variantType =SI_VT_FLOAT ;
		out_pSiVariant->fVal = in_ComVariant->fltVal;
		break;
	case VT_R8:
		out_pSiVariant->variantType = SI_VT_DOUBLE;
		out_pSiVariant->dVal = in_ComVariant->dblVal;
		break;
	case VT_I4:
		out_pSiVariant->variantType =SI_VT_LONG ;
		out_pSiVariant->lVal = in_ComVariant->lVal;
		break;
	case VT_UI4:
		out_pSiVariant->variantType = SI_VT_ULONG;
		out_pSiVariant->ulVal = in_ComVariant->ulVal;
		break;
	case VT_BYREF|VT_BOOL:
		out_pSiVariant->variantType = SI_VT_PBOOL;
		out_pSiVariant->p_boolVal = (USHORT*)in_ComVariant->pboolVal;
		break;
	case VT_BYREF|VT_I1:
		// char...
		out_pSiVariant->variantType = SI_VT_PCHAR;
		// allocate memory in XSICore which should take care of freeing it
		// in the destructor of the template
		out_pSiVariant->p_cVal = _SI_STRDUP(in_ComVariant->pcVal); 
		break;
	case VT_BYREF|VT_UI1:
		out_pSiVariant->variantType = SI_VT_PUBYTE;
		out_pSiVariant->p_ubVal = in_ComVariant->pbVal;
		break;
	case VT_BYREF|VT_I2:
		out_pSiVariant->variantType = SI_VT_PSHORT;
		out_pSiVariant->p_sVal = in_ComVariant->piVal;
		break;
	case VT_BYREF|VT_UI2:
		out_pSiVariant->variantType = SI_VT_PUSHORT;
		out_pSiVariant->p_usVal = in_ComVariant->puiVal;
		break;
	case VT_BYREF|VT_INT:  
		out_pSiVariant->variantType = SI_VT_PINT;
		out_pSiVariant->p_nVal = in_ComVariant->pintVal;
		break;
	case VT_BYREF|VT_UINT:
		out_pSiVariant->variantType = SI_VT_PUINT;
		out_pSiVariant->p_unVal = in_ComVariant->puintVal;
		break;
	case VT_BYREF|VT_R4:
		out_pSiVariant->variantType = SI_VT_PFLOAT;
		out_pSiVariant->p_fVal = in_ComVariant->pfltVal;
		break;
	case VT_BYREF|VT_R8:
		out_pSiVariant->variantType = SI_VT_PDOUBLE;
		out_pSiVariant->p_dVal = in_ComVariant->pdblVal;
		break;
	case VT_BYREF|VT_I4:
		out_pSiVariant->variantType = SI_VT_PLONG;
		out_pSiVariant->p_lVal = in_ComVariant->plVal;
		break;
	case VT_BYREF|VT_UI4:
		out_pSiVariant->variantType = SI_VT_PULONG;
		out_pSiVariant->p_ulVal = in_ComVariant->pulVal;
		break;
	case VT_BSTR:
		////////////////////////////////////////////////////////////
		// IMPORTANT NOTE:
		// The BSTR will be parsed and converted to an array of string.
		// EACH String in the BSTR need to be terminated by a '\0'
		// Another '\0' needs to be appended after the LAST string.
		////////////////////////////////////////////////////////////
		out_pSiVariant->variantType = SI_VT_PPCHAR;
		return COM2SIStringArrayConv(in_ComVariant, out_pSiVariant);
		break;
	case VT_BYREF:
		out_pSiVariant->variantType =SI_VT_PVOID ;
		out_pSiVariant->p_voidVal = in_ComVariant->byref;
		break;
	case VT_ARRAY | VT_VARIANT:
		ConvertToSiVariant( in_ComVariant, out_pSiVariant );
		break;
	default: 
		return E_FAIL;
	}
	return S_OK;
}


HRESULT SI2COMStringArrayConv(SI_TinyVariant* in_SiVariant, VARIANT* out_pComVariant )
{
	////////////////////////////////////////////////////////////
	// The input Char* array will be put into ONE BSTR.
	// EACH String in the BSTR is terminated by a '\0'
	// Another '\0' is appended after the LAST string.
	//
	// For example, the input Char* array (in_SiVariant.pp_cVal) is an array of 3 pointers,
	// first one points to "cube1", second points to "null1", last one is null.
	// The output string will then be:
	//		"cube1\0null1\0\0"
	//
	// Note: To make the comments clear, I will call "cube1" and "null1" the names inside the string.

	// we allocate memory in this memory space. 
	// We should call FreeStringVariant() to free the memory when it's not needed anymore


	HRESULT l_hr = S_OK;

	SI_Char		**l_pString = in_SiVariant->pp_cVal;	// current name within the input string
	wchar_t		*l_pwString;						// current name within the output string
	wchar_t		*l_pwOutputString;					// that will be the output string
	SI_Long		l_lStringSize;						// string length of the current name 
	SI_Long		l_lTotalStringLen = 0;				// total length of the output string

	// compute the total length needed by the output string
	while ( *l_pString != NULL )
	{
		l_lTotalStringLen += (strlen(*l_pString) + 1);
		l_pString++;
	}
	l_lTotalStringLen++; // for the last null character

	l_pwOutputString = (wchar_t *)SysAllocStringByteLen( NULL, (l_lTotalStringLen) * sizeof( wchar_t ));
	l_pwString = l_pwOutputString;
	
	l_pString = in_SiVariant->pp_cVal;
	while ( *l_pString != NULL )
	{
		l_lStringSize = strlen(*l_pString);

		// convert from char to wchar
		mbstowcs( l_pwString, *l_pString, l_lStringSize );

		// add the null character that mbstowcs doesn't put
		l_pwString += l_lStringSize;
		wcscpy( l_pwString, L"\0" );

		// next name will be written after the null character
		l_pwString++;

		// next name
		l_pString++;

	}
	// Append a last '\0' at the end
	wcscpy( l_pwString, L"\0" );
 
	// Set the data into the Variant
	out_pComVariant->bstrVal = l_pwOutputString;

	return l_hr;
}

HRESULT COM2SIStringArrayConv(VARIANT* in_ComVariant, SI_TinyVariant* out_pSiVariant )
{
	///////////////////////////////////////////////////////////////
	// The BSTR will be parsed and converted to an array of strings.
	// The array of strings is terminated by a NULL pointer.
	// EACH String in the input BSTR is terminated by a '\0'. Another '\0' 
	// means the end of the list.
	//
	// For example, the input string is:
	//		"cube1\0null1\0\0"
	//
	// The output Char* array will be an array of 3 pointers,
	// first one points to "cube1", second points to "null1", last one is null.
	//
	// Note: To make the comments clear, I will call "cube1" and "null1" the names inside the string.

	// The allocation of the memory is done in the XSICore.dll memory space through AllocateLocalMemory().
	// XSICore will use this array directly in a template and will take care of freeing it when 
	// the destructor will be called.

	HRESULT l_hr = S_OK;

	wchar_t*	l_pData = in_ComVariant->bstrVal;	// pointer to the current name
	SI_Long		l_lStringLen = 0;					// string length of the current name
	SI_Long		l_lStringCount = 0;					// number of names in the array

	// Count the number of names in the array
	l_lStringLen = wcslen(l_pData);
	while ( l_lStringLen != 0 )	
	{	
		l_lStringCount++;

		// Go to the next name
		l_pData += (l_lStringLen + 1);
		l_lStringLen = wcslen(l_pData);
	}

	l_pData = in_ComVariant->bstrVal;

	SI_Long		l_lStringSize = 0;
	SI_Char**	l_StringArray = NULL;		// that will be the output string array
	AllocateLocalMemory(l_StringArray, l_lStringCount+1);

	// Check if memory is allocated properly
	if( l_StringArray == NULL) return E_OUTOFMEMORY;

	// Now copy it from the BSTR to the array
	for ( int i=0; i < l_lStringCount; i++)
	{
		l_lStringSize = wcslen(l_pData) + 1;

		// Convert From wchar to char
		AllocateLocalMemory( l_StringArray[i], l_lStringSize );
		
		// Check if memory is allocated properly
		if( l_StringArray[i] == NULL) return E_OUTOFMEMORY;

		wcstombs( l_StringArray[i], l_pData, l_lStringSize );
		
		// Pass to the next string
		l_pData += (l_lStringSize);
	}
	l_StringArray[l_lStringCount] = NULL; // null terminated

	// Set the Array into the SI_TinyVariant
	out_pSiVariant->pp_cVal = l_StringArray;
	out_pSiVariant->numElems = l_lStringCount;

	return l_hr;
}