/* $Header: /Src/RhinoIO/rhinoio_agface.h 5     10/28/98 12:07p Dalelear $ */
/* $NoKeywords: $ */
//
// Copyright (c) 1993-1998 Robert McNeel & Associates. All rights reserved.
// Rhinoceros is a registered trademark of Robert McNeel & Assoicates.
//
// THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
// ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF
// MERCHANTABILITY ARE HEREBY DISCLAIMED.
//				
////////////////////////////////////////////////////////////////
//
//   defines CRhinoAgFace
//
////////////////////////////////////////////////////////////////


#if !defined(RHINO_AGFACE_INC_)
#define RHINO_AGFACE_INC_

///////////////////////////////////////////////////////////////////////////////
// Class  CRhinoAgFace
//
//	This object represents an AG_FACE structure
///////////////////////////////////////////////////////////////////////////////

class CRhinoAgFace: public CRhinoBrep
{
	RHINO_CHUNK_DECLARE( CRhinoAgFace )
public:

  // Construction
	CRhinoAgFace();
  ~CRhinoAgFace();

  // CRhinoObject overrides
	CRhinoFile::eStatus Read(   	// read chunk data from file 
    CRhinoFile&
    );
	void Write(                   // Writes NURBS curve to file
                                // Throws a CRhinoException if IsValid()
                                // returns FALSE or fwrite() fails.
    CRhinoFile&
    ) const;
  BOOL IsValid(                 // Call after class is fully initialized to
                                // perform a simple and quick validity check.
                                // Will detect illegal knot vectors and
                                // incorrect settings of integer m_* members.
                                // Does NOT check control vertices for
                                // grossly degenerate conditions.
    void
    ) const;

  // Interface


// Implementation
private:
  CRhinoAgFace(const CRhinoAgFace&); // no implementation
	CRhinoAgFace& operator=(const CRhinoAgFace&); // no implementation
};

inline CRhinoAgFace::CRhinoAgFace() : CRhinoBrep( TCODE_AG_FACE ) {}
inline CRhinoAgFace::~CRhinoAgFace() {}

#endif
