/* $Header: /Src/RhinoIO/rhinoio_agshell.h 4     10/28/98 12:08p Dalelear $ */
/* $NoKeywords: $ */
//
// Copyright (c) 1993-1998 Robert McNeel & Associates. All rights reserved.
// Rhinoceros is a registered trademark of Robert McNeel & Assoicates.
//
// THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
// ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF
// MERCHANTABILITY ARE HEREBY DISCLAIMED.
//				
////////////////////////////////////////////////////////////////
//
//   defines CRhinoAgShell
//
////////////////////////////////////////////////////////////////


#if !defined(RHINO_AGSHELL_INC_)
#define RHINO_AGSHELL_INC_


///////////////////////////////////////////////////////////////////////////////
// Class  CRhinoAgShell
//
//	This object represents an AG_SHELL structure
///////////////////////////////////////////////////////////////////////////////

class CRhinoAgShell: public CRhinoBrep
{
	RHINO_CHUNK_DECLARE( CRhinoAgShell )
public:

  // Construction
	CRhinoAgShell();
  ~CRhinoAgShell();

  // CRhinoObject overrides
	CRhinoFile::eStatus Read(   	// read chunk data from file 
    CRhinoFile&
    );
	void Write(                   // Writes NURBS curve to file
                                // Throws a CRhinoException if IsValid()
                                // returns FALSE or fwrite() fails.
    CRhinoFile&
    ) const;
  BOOL IsValid(                 // Call after class is fully initialized to
                                // perform a simple and quick validity check.
                                // Will detect illegal knot vectors and
                                // incorrect settings of integer m_* members.
                                // Does NOT check control vertices for
                                // grossly degenerate conditions.
    void
    ) const;

  // Interface


// Implementation
private:
  CRhinoAgShell(const CRhinoAgShell&); // no implementation
	CRhinoAgShell& operator=(const CRhinoAgShell&); // no implementation
};

inline CRhinoAgShell::CRhinoAgShell() : CRhinoBrep( TCODE_AG_SHELL ) {}
inline CRhinoAgShell::~CRhinoAgShell() {}

#endif
