/* $Header: /Src/RhinoIO/rhinoio_exception.h 2     9/09/98 2:56p Dalelear $ */
/* $NoKeywords: $ */
//
// Copyright (c) 1993-1998 Robert McNeel & Associates. All rights reserved.
// Rhinoceros is a registered trademark of Robert McNeel & Assoicates.
//
// THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
// ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF
// MERCHANTABILITY ARE HEREBY DISCLAIMED.
//				
////////////////////////////////////////////////////////////////
//
//   Defines CRhinoException
//
////////////////////////////////////////////////////////////////

#if !defined(RHINO_EXCEPTION_INC_)
#define RHINO_EXCEPTION_INC_

///////////////////////////////////////////////////////////////////////////////
// Class CRhinoException
//   The functions in this toolkit throw exceptions when they encounter serious
//   errors.  These can be system errors (e.g. out_of_memory), file I/O
//   errors, or programmer error in calling the functions(e.g.illegal_input) A
//   programmer who wants to recover from any of these errors must enclose
//   the calling code in a try block and provide a catch block: 
//          catch (CRhinoException) { 
//				// handle exception here
//			} 
///////////////////////////////////////////////////////////////////////////////
class CRhinoException{
public:

	enum type {
		unable_to_write,
		unable_to_read,
		unable_to_seek,
		unexpected_end_of_file,
		unexpected_value,
		not_supported,
		illegal_input,
		out_of_memory  } m_type;

	CRhinoException( type );
};

inline CRhinoException::CRhinoException( CRhinoException::type t )
  { m_type = t;}


#endif
