/* $Header: /Src/RhinoIO/rhinoio_layerindex.h 3     9/09/98 2:53p Dalelear $ */
/* $NoKeywords: $ */
//
// Copyright (c) 1993-1998 Robert McNeel & Associates. All rights reserved.
// Rhinoceros is a registered trademark of Robert McNeel & Assoicates.
//
// THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
// ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF
// MERCHANTABILITY ARE HEREBY DISCLAIMED.
//				
////////////////////////////////////////////////////////////////
//
//   defines CRhinoLayerIndex
//
////////////////////////////////////////////////////////////////

#if !defined(RHINO_LAYERINDEX_INC_)
#define RHINO_LAYERINDEX_INC_

///////////////////////////////////////////////////////////////////////////////
// Class CRhinoLayerIndex
//		The enclosing object is on a layer.  The info field is an index into
//    the files layer table. 
///////////////////////////////////////////////////////////////////////////////

class CRhinoLayerIndex: public CRhinoChunk 
{
	RHINO_CHUNK_DECLARE( CRhinoLayerIndex )
public:
	CRhinoLayerIndex( int = 0 /* index */ );
	~CRhinoLayerIndex( );
	
	int Index( void ) const;				// index into a layer table 
	void SetIndex( int );		
};
 
inline int CRhinoLayerIndex::Index( void ) const
  { return Value(); }

inline void CRhinoLayerIndex::SetIndex( int i )
  { SetValue((i>=0) ? i : 0); }

inline CRhinoLayerIndex::CRhinoLayerIndex( int index /* = 0 */ ) 
                  : CRhinoChunk( TCODE_LAYERREF, index )
  {SetIndex(index);}

inline CRhinoLayerIndex::~CRhinoLayerIndex( ) 
  {}

#endif
