/* $Header: /Src/RhinoIO/rhinoio_name.cpp 3     1/07/00 9:34a Dalelear $ */
/* $NoKeywords: $ */
//
// Copyright (c) 1993-2000 Robert McNeel & Associates. All rights reserved.
// Rhinoceros is a registered trademark of Robert McNeel & Assoicates.
//
// THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
// ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF
// MERCHANTABILITY ARE HEREBY DISCLAIMED.
//				
////////////////////////////////////////////////////////////////

#include "rhinoio_def.h"
#include "rhinoio_exception.h"
#include "rhinoio_layerptr.h"
#include "rhinoio_file.h"
#include "rhinoio_chunk.h"
#include "rhinoio_name.h"


RHINO_CHUNK_IMPLEMENT(CRhinoName,TCODE_NAME)

CRhinoName::CRhinoName( const char* sName ) : CRhinoChunk( TCODE_NAME )
{
  m_sName = NULL;
  SetName( sName );
}

void CRhinoName::Write( CRhinoFile& file ) const
{
  file.BeginWriteChunk( *this );
  file.WriteString( m_sName );
  file.EndChunk();
}

CRhinoFile::eStatus CRhinoName::Read( CRhinoFile& file )
{
  CRhinoFile::eStatus status = CRhinoFile::good;
  if ( m_sName ) 
    delete m_sName;
  m_sName = NULL;
  file.ReadString( m_sName );
  if ( m_sName && !m_sName[0] ) {
    delete m_sName;
    m_sName = NULL;
  }
  return status;
}

void CRhinoName::SetName( const char* sName )
{
  delete m_sName;
  m_sName = NULL;
  if ( sName && sName[0] ) {
    const int name_length = strlen( sName );
    m_sName = new char[name_length+1];
    m_sName[name_length] = 0;
    strcpy( m_sName, sName );
  }
}
