/* $Header: /Src/RhinoIO/rhinoio_name.h 4     1/07/00 9:34a Dalelear $ */
/* $NoKeywords: $ */
//
// Copyright (c) 1993-2000 Robert McNeel & Associates. All rights reserved.
// Rhinoceros is a registered trademark of Robert McNeel & Assoicates.
//
// THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
// ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF
// MERCHANTABILITY ARE HEREBY DISCLAIMED.
//				
////////////////////////////////////////////////////////////////
//
//   defines CRhinoName
//
////////////////////////////////////////////////////////////////

#if !defined(RHINO_NAME_INC_)
#define RHINO_NAME_INC_

class CRhinoName: public CRhinoChunk 
{
	RHINO_CHUNK_DECLARE( CRhinoName )
public:

  // construction
	CRhinoName();
	CRhinoName(const char*);
	~CRhinoName();
		
	// virtual overrides
	void Write(CRhinoFile &) const;		// write chunk to file. 
	CRhinoFile::eStatus Read(CRhinoFile&);							

  // interface
  const char* Name( void ) const;	// object name
	void SetName( const char* );	
  int Length( void ) const;

private:
	char* m_sName;
};

////////////////////////////////////////////////////////////////

inline CRhinoName::CRhinoName()
: CRhinoChunk( TCODE_NAME )
  {m_sName=NULL;}

inline CRhinoName::~CRhinoName()
  {delete m_sName;}

inline const char* CRhinoName::Name( void ) const
  {return m_sName;}

inline int CRhinoName::Length( void ) const
  {return (m_sName) ? strlen( m_sName ) : 0;}

#endif
