/* $Header: /Src/RhinoIO/rhinoio_notes.h 3     10/18/99 10:07a Dalelear $ */
/* $NoKeywords: $ */
//
// Copyright (c) 1993-1999 Robert McNeel & Associates. All rights reserved.
// Rhinoceros is a registered trademark of Robert McNeel & Assoicates.
//
// THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
// ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF
// MERCHANTABILITY ARE HEREBY DISCLAIMED.
//				
////////////////////////////////////////////////////////////////


#if !defined(RHINO_NOTES_INC_)
#define RHINO_NOTES_INC_

///////////////////////////////////////////////////////////////////////////////
// Class CRhinoNotes
///////////////////////////////////////////////////////////////////////////////
class CRhinoNotes : public CRhinoChunk
{
	RHINO_CHUNK_DECLARE( CRhinoNotes )
public:

  // construction
  CRhinoNotes();
  ~CRhinoNotes();

  // virtual overrides
	CRhinoFile::eStatus Read( CRhinoFile& );
	void Write( CRhinoFile& ) const;

  // interface
  const char *String() const;

  void SetString( const char *psz);

private:
  // This is what is in the rhino file
  int   m_nVisible; // 1. Notes visible flag
  int   m_rect[4];  // 2. Notes window rect
  char *m_psz;      // 4. (3. int nLenght = String length) Notes string
};

#endif
