/* $Header: /Src/RhinoIO/rhinoio_tolerances.h 1     3/18/99 11:58a Dalelear $ */
/* $NoKeywords: $ */
//
// Copyright (c) 1993-1998 Robert McNeel & Associates. All rights reserved.
// Rhinoceros is a registered trademark of Robert McNeel & Assoicates.
//
// THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
// ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF
// MERCHANTABILITY ARE HEREBY DISCLAIMED.
//				
////////////////////////////////////////////////////////////////
//
//   defines CRhinoUnitsAndTolerances
//
////////////////////////////////////////////////////////////////

#if !defined(RHINO_TOLERANCES_INC_)
#define RHINO_TOLERANCES_INC_

///////////////////////////////////////////////////////////////////////////////
// Class CRhinoUnitsAndTolerances
//   The unit system and tolerances are saved in a single chunk.
///////////////////////////////////////////////////////////////////////////////
class CRhinoUnitsAndTolerances : public CRhinoChunk
{
	RHINO_CHUNK_DECLARE(CRhinoUnitsAndTolerances)
private:
	void Write( CRhinoFile& ) const;					// Outputs a chunk defining this layer
	CRhinoFile::eStatus Read( CRhinoFile& );	// read chunk data
  double m_abs_tol;
  double m_rel_tol;
  double m_ang_tol;
  CRhinoFile::eUnitSystem m_units;
	CRhinoUnitsAndTolerances();
	~CRhinoUnitsAndTolerances();
	friend class CRhinoFile;
};

#endif
