/* $Header: /Src/RhinoIO/rhinoio_workspace.cpp 3     10/20/99 1:28p Dalelear $ */
/* $NoKeywords: $ */
//
// Copyright (c) 1993-1998 Robert McNeel & Associates. All rights reserved.
// Rhinoceros is a registered trademark of Robert McNeel & Assoicates.
//
// THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
// ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF
// MERCHANTABILITY ARE HEREBY DISCLAIMED.
//				
////////////////////////////////////////////////////////////////

#include "rhinoio_def.h"

CRhinoWorkSpace::~CRhinoWorkSpace()
{
  struct MEMBLK* p = m_pMemBlk;
  while ( p ) {
    struct MEMBLK* next = p->next;
    rhfree((void*)p);
    p = next;
  }
}

void* CRhinoWorkSpace::GetMemory( size_t size )
{
	void* p = NULL;
	if ( size > 0 ) {
		struct MEMBLK* pBlk = NULL;
		size_t blk_size = sizeof(*pBlk);
		if ( blk_size % 16 ) {
			blk_size = (blk_size/16 + 1)*16;
		}
    char* pByte = (char*)rhmalloc(blk_size + size);
    pBlk = (struct MEMBLK*)pByte;
    p = (void*)(pByte + blk_size);
		pBlk->next = m_pMemBlk;
    m_pMemBlk = pBlk;
	}
	return p;
}


