/* $Header: /Src/RhinoIO/rhinoio_xdata.h 1     9/27/99 3:17p Dalelear $ */
/* $NoKeywords: $ */
//
// Copyright (c) 1993-1999 Robert McNeel & Associates. All rights reserved.
// Rhinoceros is a registered trademark of Robert McNeel & Assoicates.
//
// THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
// ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF
// MERCHANTABILITY ARE HEREBY DISCLAIMED.
//				
////////////////////////////////////////////////////////////////
//
//   defines CRhinoXdata, 
//
////////////////////////////////////////////////////////////////

#if !defined(RHINO_XDATA_INC_)
#define RHINO_XDATA_INC_

///////////////////////////////////////////////////////////////////////////////
// Class CRhinoXdata
//   This chunk stores arbitrary data buffers used for a variety of things
///////////////////////////////////////////////////////////////////////////////

class CRhinoXdata: public CRhinoChunk 
{
	RHINO_CHUNK_DECLARE( CRhinoXdata )
public:

  // construction
	CRhinoXdata();
	~CRhinoXdata();
		
	// virtual overrides
	void Write(CRhinoFile &) const;		// write chunk to file. 
	CRhinoFile::eStatus Read(CRhinoFile&);							

  // interface
  const char* Id(void) const;
  size_t BufferSize(void) const;
  const void*  BufferData(void) const;

private:
	char*  m_sId;
  int    m_buffer_size;
  void*  m_buffer_data;
};


#endif
